﻿using System.Windows.Input;

using CommunityToolkit.Maui.Behaviors;
using CommunityToolkit.Maui.Converters;

namespace TestProject;

/// <summary>
/// 메인 페이지
/// </summary>
public partial class MainPage : ContentPage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 항목 리스트 - ItemList

    /// <summary>
    /// 항목 리스트
    /// </summary>
    public List<string> ItemList { get; set; }

    #endregion
    #region 선택 항목 - SelectedItem

    /// <summary>
    /// 선택 항목
    /// </summary>
    public string SelectedItem { get; set; }

    #endregion
    #region 항목 선택시 명령 - ItemSelectedCommand

    /// <summary>
    /// 항목 선택시 명령
    /// </summary>
    public ICommand ItemSelectedCommand { get; private set; }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - MainPage()

    /// <summary>
    /// 생성자
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        ItemList = new List<string>()
        {
            "광주",
            "대전",
            "대구",
            "목포",
            "부산",
            "서울",
            "수원",
            "울산",
            "포항"
        };

        SelectedItem = ItemList[1];

        ItemSelectedCommand = new Command<string>
        (
            async (e) =>
            {
                await DisplayAlert("INFORMATION", $"{e} 항목을 선택하였습니다.", "확인");
            }
        );

        SelectedItemEventArgsConverter converter = new SelectedItemEventArgsConverter();

        EventToCommandBehavior behavior = new EventToCommandBehavior();

        behavior.EventName          = nameof(ListView.ItemSelected);
        behavior.EventArgsConverter = converter;

        behavior.SetBinding(EventToCommandBehavior.CommandProperty, nameof(ItemSelectedCommand));

        this.listView.Behaviors.Add(behavior);

        BindingContext = this;
    }

    #endregion
}